package etudeCasUML;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Classe Client pour étude de Cas du cours
 * @author Colette Johnen
 * @version 1.0 
 * @since december 2014
 */
public class Client {
	private int numClt;
	private static int nombreClients=0;
	private Collection<Commande> mesCommandes;
	private Collection<Facture> mesFactures;
	private Collection<Facture> mesFacturesPayees;
	private Collection<Commande> mesCommandesFacturees;
	
	private String nom;
	private String prenom;
	private String adresse;
	private int etatClient; // 1 est d�biteur
	
	public String getNom() {return nom;}
	
	public Client(String nom) {
		this.nom = nom;
		 mesCommandes = new ArrayList<Commande>();
		 mesFactures = new ArrayList<Facture>();
		 mesFacturesPayees = new ArrayList<Facture>();
		 mesCommandesFacturees = new ArrayList<Commande>();
	}
	
	public void aPayer(){
		ArrayList<Facture> factures = new ArrayList<Facture>();
		for (Facture facture : mesFactures) 	
			if (facture.getDatePaiement() != null)  {
				factures.add(facture); 	}
		mesFactures.removeAll(factures);
		mesFacturesPayees.addAll(factures);
		if (mesFactures.isEmpty()) this.estAJour();
	}
		
	
	public void estDebiteur() {etatClient = 1;}
	public void estAJour() {etatClient = 0; }
	
	public void factureADetruire(Facture facture, Collection<Commande> mesCmds) {
        mesFactures.remove(facture);
        mesCommandesFacturees.removeAll(mesCmds);
	}
	
	public Commande arrCommande(String description, float cout){
		if (etatClient == 1)
		{
			System.out.println("ENV refus Commande � "+nom); 
			return  null;
		}
		Commande cmd = new Commande(description, cout);
		mesCommandes.add(cmd);
		System.out.print("ENV Bon fabrication de "+description);
		System.out.println(" pay� par "+nom);
		return cmd;
	}
	
	public Facture arrFinMois() {
		ArrayList<Commande> commandesAPayees ;
		commandesAPayees = new ArrayList<Commande>();
		if (mesCommandes.isEmpty()) return null;
		for (Commande cmd : mesCommandes) 	
			if (cmd.getDateRealisation()!= null)
				commandesAPayees.add(cmd);
		if (commandesAPayees.isEmpty()) return null;
		mesCommandes.removeAll(commandesAPayees);
		mesCommandesFacturees.addAll(commandesAPayees);
		Facture fact= new Facture(this,commandesAPayees);
		mesFactures.add(fact);
		return fact;
	}
}
