package etudeCasUML;

import java.util.Calendar;
import java.util.Collection;
/**
 * Classe Facture pour étude de Cas du cours
 * @author Colette Johnen
 * @version 1.0 
 * @since december 2014
 */
public class Facture {
  private int numFacture;
  private static int nombreFactures = 0;
  private float totalFacture;
  private Calendar dateFacture;
  private Calendar datePaiement=null;
  private Calendar dateRelance=null;
  private static int delaiRelance = 10;
  private static int delaiArchivage = 15;
  private Collection<Commande> mesCommandes;
  private Client monPayeur;
  
  public Calendar getDatePaiement() { return datePaiement;}
  public float  getMontant() { return totalFacture;}
  
  
  public void arrPaiement(float somme) {
	  if (somme == totalFacture) {
		  datePaiement = Calendar.getInstance();
		  monPayeur.aPayer();
		  System.out.print("Paiement facture par "+monPayeur.getNom());
		  System.out.println(" d'un montant  "+totalFacture);
	  }
  }
  
  public void arrDateRelance() {
	  if (datePaiement == null) monPayeur.estDebiteur(); 
	  System.out.print("ENV relance de la ");
	  this.affichage();
  }
  
  private void affichage() {
	  System.out.print("facture � "+monPayeur.getNom());
	  System.out.println(" d'un montant  "+totalFacture);
	  for (Commande cmd : mesCommandes) 
		  System.out.println("  "+cmd);
  }
  
  public void arrDateFinArchivage() {
	  monPayeur.factureADetruire(this, mesCommandes);}
  
  public Facture(Client payeur, Collection<Commande> mesCmds) {
	  numFacture = nombreFactures++;
	  monPayeur = payeur; 
	  mesCommandes = mesCmds;
	  dateFacture = Calendar.getInstance();
	  totalFacture = 0;
	  for (Commande cmd : mesCommandes) 
		  totalFacture =+ cmd.getMontant();
	  System.out.print("ENV facture ");
	  		this.affichage();
  }
}
